clang 8.0.0

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::OMPNumThreadsClause Class Reference

This represents 'num_threads' clause in the '#pragma omp ...' directive. More...

`#include "clang/AST/OpenMPClause.h"`

Inheritance diagram for clang::OMPNumThreadsClause:
[legend]
Collaboration diagram for clang::OMPNumThreadsClause:
[legend]

## Public Member Functions
| OMPNumThreadsClause (Expr *NumThreads, Stmt *HelperNumThreads, OpenMPDirectiveKind CaptureRegion, SourceLocation StartLoc, SourceLocation LParenLoc, SourceLocation EndLoc)
| Build 'num_threads' clause with condition NumThreads. More...
| OMPNumThreadsClause ()
| Build an empty clause. More...
void | setLParenLoc (SourceLocation Loc)
| Sets the location of '('. More...
SourceLocation | getLParenLoc () const
| Returns the location of '('. More...
Expr * | getNumThreads () const
| Returns number of threads. More...
child_range | children ()
Public Member Functions inherited from clang::OMPClause
SourceLocation | getBeginLoc () const
| Returns the starting location of the clause. More...
SourceLocation | getEndLoc () const
| Returns the ending location of the clause. More...
void | setLocStart (SourceLocation Loc)
| Sets the starting location of the clause. More...
void | setLocEnd (SourceLocation Loc)
| Sets the ending location of the clause. More...
OpenMPClauseKind | getClauseKind () const
| Returns kind of OpenMP clause (private, shared, reduction, etc.). More...
bool | isImplicit () const
child_range | children ()
const_child_range | children () const
Public Member Functions inherited from clang::OMPClauseWithPreInit
const Stmt * | getPreInitStmt () const
| Get pre-initialization statement for the clause. More...
Stmt * | getPreInitStmt ()
| Get pre-initialization statement for the clause. More...
OpenMPDirectiveKind | getCaptureRegion () const
| Get capture region for the stmt in the clause. More...

## Static Public Member Functions
static bool | classof (const OMPClause *T)
Static Public Member Functions inherited from clang::OMPClause
static bool | classof (const OMPClause *)
Static Public Member Functions inherited from clang::OMPClauseWithPreInit
static OMPClauseWithPreInit * | get (OMPClause *C)
static const OMPClauseWithPreInit * | get (const OMPClause *C)

## Friends
class | OMPClauseReader

## Additional Inherited Members
Public Types inherited from clang::OMPClause
using | child_iterator = StmtIterator
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Member Functions inherited from clang::OMPClause
| OMPClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation EndLoc)
Protected Member Functions inherited from clang::OMPClauseWithPreInit
| OMPClauseWithPreInit (const OMPClause *This)
void | setPreInitStmt (Stmt *S, OpenMPDirectiveKind ThisRegion=OMPD_unknown)
| Set pre-initialization statement for the clause. More...

## Detailed Description

This represents 'num_threads' clause in the '#pragma omp ...' directive.

#pragma omp parallel num_threads(6)

In this example directive '#pragma omp parallel' has simple 'num_threads' clause with number of threads '6'.

Definition at line 382 of file OpenMPClause.h.

## Constructor & Destructor Documentation

## ◆ OMPNumThreadsClause() [1/2]

clang::OMPNumThreadsClause::OMPNumThreadsClause | ( | Expr * | NumThreads,
|  | Stmt * | HelperNumThreads,
|  | OpenMPDirectiveKind | CaptureRegion,
|  | SourceLocation | StartLoc,
|  | SourceLocation | LParenLoc,
|  | SourceLocation | EndLoc
| ) |  |
| inline

Build 'num_threads' clause with condition NumThreads.

Parameters

  NumThreads | Number of threads for the construct.
  HelperNumThreads | Helper Number of threads for the construct.
  CaptureRegion | Innermost OpenMP region where expressions in this clause must be captured.
  StartLoc | Starting location of the clause.
  LParenLoc | Location of '('.
  EndLoc | Ending location of the clause.

Definition at line 404 of file OpenMPClause.h.

## ◆ OMPNumThreadsClause() [2/2]

clang::OMPNumThreadsClause::OMPNumThreadsClause | ( |  | ) |
| inline

Build an empty clause.

Definition at line 415 of file OpenMPClause.h.

## Member Function Documentation

## ◆ children()

child_range clang::OMPNumThreadsClause::children | ( |  | ) |
| inline

Definition at line 428 of file OpenMPClause.h.

## ◆ classof()

static bool clang::OMPNumThreadsClause::classof | ( | const OMPClause * | T | ) |
| inline static

Definition at line 430 of file OpenMPClause.h.

References clang::OMPClause::getClauseKind().

## ◆ getLParenLoc()

SourceLocation clang::OMPNumThreadsClause::getLParenLoc | ( |  | ) | const
| inline

Returns the location of '('.

Definition at line 423 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::OMPClauseWriter::VisitOMPClauseWithPostUpdate().

## ◆ getNumThreads()

Expr* clang::OMPNumThreadsClause::getNumThreads | ( |  | ) | const
| inline

Returns number of threads.

Definition at line 426 of file OpenMPClause.h.

Referenced by OMPIsDevicePtrClause::CreateEmpty(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::OMPClauseWriter::VisitOMPClauseWithPostUpdate().

## ◆ setLParenLoc()

void clang::OMPNumThreadsClause::setLParenLoc | ( | SourceLocation | Loc | ) |
| inline

Sets the location of '('.

Definition at line 420 of file OpenMPClause.h.

Referenced by clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## Friends And Related Function Documentation

## ◆ OMPClauseReader

friend class OMPClauseReader
| friend

Definition at line 383 of file OpenMPClause.h.

The documentation for this class was generated from the following file:

- include/clang/AST/OpenMPClause.h